﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using mshtml;
using System.Windows.Threading;

namespace WpfApplication1 {
	/// <summary>
	/// Логика взаимодействия для MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {

		HTMLDocument dom;
		Timer timer;

		public MainWindow() {
			InitializeComponent();
			//Uri uri = new Uri(@"https://s3-eu-west-1.amazonaws.com/lmax-widget3/website-widget-vwap.html");
			Uri uri = new Uri(@"https://s3-eu-west-1.amazonaws.com/lmax-widget3/website-widget-quote-vwap-flex.html", UriKind.Absolute);
			WB.Navigate(uri);
		}

		private void TimerCall(object state) {
			var bidv = dom.getElementById("lw_vwap_bid");
			if (bidv != null) {
				this.Dispatcher.BeginInvoke(DispatcherPriority.Normal, (ThreadStart)delegate () {
					this.txbid.Content = "BID: " + bidv.innerText;
				});
			}
			var askv = dom.getElementById("lw_vwap_ask");
			if (askv != null) {
				this.Dispatcher.BeginInvoke(DispatcherPriority.Normal, (ThreadStart)delegate () {
					this.txask.Content = "ASK: " + askv.innerText;
				});
			}
			var spreadv = dom.getElementById("lw_vwap_spread");
			if (spreadv != null) {
				this.Dispatcher.BeginInvoke(DispatcherPriority.Normal, (ThreadStart)delegate () {
					this.txspread.Content = "SPREAD: " + spreadv.innerText;
				});
			}
		}

		private void WB_LoadCompleted(object sender, NavigationEventArgs e) {
			// Объект DOM из WebBrowser
			dom = (HTMLDocument)WB.Document;
			timer = new Timer(TimerCall, null, 1000, 200);
		}

		private void Window_Closed(object sender, EventArgs e) {
			if (timer != null) { timer.Dispose(); }
		}
	}
}
